<?php

namespace BmbyForms\Callbacks;

use function BmbyForms\Requests\bf_get_dyn_var_request;

/**
 * @return void
 */
function bf_update_dyn_vars_callback() {
	global $wpdb;
	$dynVarsStr = bf_get_dyn_var_request();

	$dynVars = json_decode($dynVarsStr, true);
	if (isset($dynVars['error']))
		return;

	delete_option('bf_dyn_vars');
	add_option('bf_dyn_vars', $dynVarsStr);

	$dynTitleIDs = [];
	foreach ($dynVars as $dynVar) {
		$dynTitleIDs[] = $dynVar['DynTitleID'];
	}

	$rawOptionValues = $wpdb->get_results( "SELECT option_name, option_value FROM {$wpdb->options} WHERE option_name LIKE 'bf_match_%';" );

	$optionValues = [];
	foreach ($rawOptionValues as $rawOptionValue) {
		$optionValues[$rawOptionValue->option_name] = unserialize($rawOptionValue->option_value);
	}

	foreach ($optionValues as $optionName => $optionValue) {
		$newOptionValue = $optionValue;
		foreach ($optionValue['fields'] as $key => $field) {
			if ($field > 0 && array_search($field, $dynTitleIDs) === false) {
				unset($newOptionValue['fields'][$key]);
			}
		}
		update_option($optionName, $newOptionValue);
	}
}
