<?php

namespace BmbyForms\Interceptors;

use WPCF7_ContactForm;

/**
 * Add custom css
 */
function bf_cf7_form_structure_updated($form) {
	global $cf7FormExcludedElements;

	$formTitle = WPCF7_ContactForm::get_instance($form->id())->title();
	if (!$formTitle) {
		return;
	}

	$formDescriptor = base64_encode("{$form->id()}:Contact Form 7:{$formTitle}");
	$formMapping = get_option("bf_match_{$formDescriptor}");
	if (!$formMapping) {
		return;
	}

	$scannedTags = WPCF7_ContactForm::get_instance($form->id())->scan_form_tags();
	$formElementNames = [];
	foreach ($scannedTags as $key => $scannedTag) {
		if (array_search($scannedTag->basetype, $cf7FormExcludedElements) !== false) {
			continue;
		}

		$formElementNames[] = $scannedTag->raw_name;
	}

	$formMapping['fields'] = array_filter($formMapping['fields'], function ($bmbyFieldId, $wordpressFieldName) use ($formElementNames) {
		return array_search($wordpressFieldName, $formElementNames) !== false;
	}, ARRAY_FILTER_USE_BOTH);

	update_option("bf_match_{$formDescriptor}", $formMapping);
}
