<?php

namespace BmbyForms\Interceptors;

use function BmbyForms\Requests\bf_create_lead_request;

/**
 * @return void
 */
function bf_create_lead_after_new_user_registered($data) {
	global $wpdb;

	$dataToSend['Fname'] = $data['first_name'];
	$dataToSend['Lname'] = $data['last_name'];
	$dataToSend['Email'] = $data['email'];
	$dataToSend['Mobile'] = $data['tel'];

	$responseBody = bf_create_lead_request($dataToSend);

	$sql = $wpdb->prepare( "SELECT option_value FROM {$wpdb->options} WHERE {$wpdb->options}.option_name = %s LIMIT 1;", 'bf_meta_field');
	$metaField = isset($wpdb->get_results($sql)[0]->option_value) ? $wpdb->get_results($sql)[0]->option_value : null;
	//do not use wp_get_current_user because unlike in other form interceptors user is not logged in yet
	$user = get_user_by('ID', $data['user_id']);

	if (!empty($responseBody['clientID']) && get_option('bf_product_api_key', null) && $metaField && is_a($user, 'WP_User')) {
		if (!is_super_admin($user->ID) && !in_array('administrator', $user->roles)) {
			$existedClientIDs = get_user_meta($user->ID, $metaField);
			if (!$existedClientIDs || !in_array($responseBody['clientID'], $existedClientIDs)) {
				add_metadata('user', $user->ID, $metaField, $responseBody['clientID']);
			}

			if ($responseBody['isReturningCustomer'] == true && $returningUserRole = get_option('bf_returning_user_role')) {
				$user->add_role($returningUserRole);
			}
		}
	}
}
