<?php

namespace BmbyForms\Interceptors;

use ElementorPro\Plugin;
use RecursiveArrayIterator;
use RecursiveIteratorIterator;

/**
 * @param $post_id
 */
function bf_elementor_form_structure_updated( $post_id ) {
	global $elementorFormExcludedElements;

	$document = Plugin::elementor()->documents->get($post_id);
	if (!$document) {
		return;
	}

	$data = $document->get_elements_data();
	if ($data) {
		$arrayIterator = new RecursiveArrayIterator($data);
		$recursiveIterator = new RecursiveIteratorIterator($arrayIterator, RecursiveIteratorIterator::SELF_FIRST);

		foreach ($recursiveIterator as $key => $value) {
			$formDescriptor = base64_encode("{$post_id}:Elementor Form:{$value['form_name']}");
			$formMapping = get_option("bf_match_{$formDescriptor}");
			if ($key === 'settings' && !empty($value['form_name']) && !empty($value['form_fields'])) {
				$formElementNames = [];
				foreach ($value['form_fields'] as $form_field) {
					if (isset($form_field['field_type']) && array_search($form_field['field_type'], $elementorFormExcludedElements) !== false) {
						continue;
					}

					$formElementNames[] = !empty($form_field['custom_id']) ? $form_field['custom_id'] : "field_{$form_field['_id']}";
				}

				$formMapping['fields'] = array_filter($formMapping['fields'], function ($bmbyFieldId, $wordpressFieldName) use ($formElementNames) {
					return array_search($wordpressFieldName, $formElementNames) !== false;
				}, ARRAY_FILTER_USE_BOTH);

				update_option("bf_match_{$formDescriptor}", $formMapping);
			}
		}
	}
}
