<?php

namespace BmbyForms\Interceptors;

use function BmbyForms\Requests\bf_create_lead_request;

/**
 * @return void
 */
function bf_elementor_form_submit_interceptor($record, $handler) {
	global $bfAllWordpressAndBmbyFormElements;

	$formName = $record->get_form_settings('form_name');
	$pageId = $record->get_form_settings('form_post_id');
	$formDescriptor = base64_encode("{$pageId}:Elementor Form:{$formName}");

	//for testing of lead creation during new user registration
//	if ($formName == 'create_user_form') {
//		$postedData = $record->get_formatted_data();
//		if (!empty($postedData['Username']) && !empty($postedData['Email'])) {
//			wp_insert_user([
//				'user_pass' => $postedData['Password'],
//				'user_login' => $postedData['Username'],
//				'user_email' => $postedData['Email'],
//				'first_name' => $postedData['First Name'],
//				'last_name' => $postedData['Last Name']
//			]);
//
//			do_action('jet-engine-booking/user_register', [
//				'first_name' => $postedData['First Name'],
//				'last_name' => $postedData['Last Name'],
//				'email' => $postedData['Email'],
//				'tel' => $postedData['Mobile'],
//			]);
//		}
//
//		return;
//	} else if ($formName == 'create_price_offer') {
//		//for testing price offer creating
//		$postedData = $record->get_formatted_data();
//		if (!empty($postedData['Product ID'])) {
//			header(sprintf("Location: %s/?feed=bmby-forms/callbacks/price-offers&product-id=%d", home_url(), $postedData['Product ID']));
//		}
//
//		return;
//	}

	$formData = get_option("bf_match_{$formDescriptor}");
	if (!$formData) {
		//if no corresponding form data in a table intercept nothing and just return
		return;
	}

	if (empty($formData['form_title']) || empty($formData['fields'])) {
		//if data is corrupted no interception
		return;
	}

	$postedData = $record->get('fields');

	foreach ($postedData as $postedField) {
		$mediator[$postedField['id']] = $postedField['raw_value'];
	}

	$formElements = [];
	foreach ($bfAllWordpressAndBmbyFormElements as $formElement) {
		$formElements[$formElement['id']] = $formElement['bmby_field'];
	}

	$dataToSend = [];
	foreach ($formData['fields'] as $key => $value) {
		if ($value < 0) {
			$dataToSend[$formElements[$value]] = !empty($mediator[$key]) ? $mediator[$key] : null;
		}
		else {
			$dataToSend['DynVars'][$value] = !empty($mediator[$key]) ? $mediator[$key] : null;
			$dataToSend['DynMongoVars'][$value] = !empty($mediator[$key]) ? $mediator[$key] : null;
		}
	}

	$responseBody = bf_create_lead_request($dataToSend);

	if (!empty($responseBody['clientID']) && get_option('bf_product_api_key', null) && $metaField = get_option('bf_meta_field', null)) {
		$loggedInUser = wp_get_current_user();
		if (!is_super_admin($loggedInUser->ID) && !in_array('administrator', $loggedInUser->roles)) {
			$existedClientIDs = get_user_meta($loggedInUser->ID, $metaField);
			if (!$existedClientIDs || !in_array($responseBody['clientID'], $existedClientIDs)) {
				add_metadata('user', $loggedInUser->ID, $metaField, $responseBody['clientID']);
			}

			if ($responseBody['isReturningCustomer'] == true && $returningUserRole = get_option('bf_returning_user_role')) {
				$loggedInUser->add_role($returningUserRole);
			}
		}
	}
}
