<?php

namespace BmbyForms\Pages\FormFieldsPage;

use function BmbyForms\bf_get_redirect_url;

/**
 * Save form matches
 *
 * @return void
 */
function bf_form_fields_post_request_handler () {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce']) && !empty($_POST['form_descriptor']) && !empty($_POST['fields'])) {
		require_once __DIR__ . '/../../../bmby-check-api-data.php';

		$formDescriptor = $_POST['form_descriptor'];

		$fields = [];
		foreach ($_POST['fields'] as $key => $value) {
			$fieldKey = base64_decode($key);
			$fields[$fieldKey] = $value;
		}

		$fields = array_filter($fields);

		if (count(array_unique($fields)) < count($fields)) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate('Every bmby field can be set and matched only to one wordpress field!', 'bmby-forms');

			wp_redirect("{$redirectUrl}?page=bmby-forms%2Fwordpress-forms.php"); exit();
		}

		$formData = [
			'form_title' => $_POST['form_title'],
			'fields' => $fields
		];

		delete_option("bf_match_{$formDescriptor}");
		add_option("bf_match_{$formDescriptor}", $formData);

		$_SESSION['flashMessage'] = translate('Match between wordpress and bmby form is successfully saved', 'bmby-forms');
		wp_redirect("{$redirectUrl}?page=bmby-forms%2Fwordpress-forms.php");
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('An error has occurred while saving wordpress and bmby forms match!', 'bmby-forms');

		wp_redirect("{$redirectUrl}?page=bmby-forms%2Fwordpress-forms.php"); exit();
	}
}
