<?php

namespace BmbyForms\Pages\SettingsPage;

use Exception;
use function BmbyForms\bf_get_redirect_url;

/**
 * Delete custom column names for bmby products
 *
 * @return void
 */
function bf_delete_product_column_names_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'])) {
		try {
			delete_option('bf_column_id');
			delete_option('bf_column_catalog');
			delete_option('bf_column_title');
			delete_option('bf_column_price');
			delete_option('bf_column_start_date');
			delete_option('bf_column_end_date');

			$_SESSION['flashMessage'] = translate('Product column names has been successfully deleted', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error during column names removal', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
