<?php

namespace BmbyForms\Pages\SettingsPage;

use function BmbyForms\bf_get_redirect_url;

/**
 * @return void
 */
function bf_delete_product_meta_fields_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'])) {
		try {
			delete_option('bf_meta_product_product_id');
			delete_option('bf_meta_product_product_type');
			delete_option('bf_meta_product_price');
			delete_option('bf_meta_product_sku');
			delete_option('bf_meta_product_start_date');
			delete_option('bf_meta_product_end_date');
			delete_option('bf_meta_product_site');

			$_SESSION['flashMessage'] = translate('Product meta fields are removed', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (\Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while product meta fields removal', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
