<?php

namespace BmbyForms\Pages\SettingsPage;

use function BmbyForms\bf_get_redirect_url;

/**
 * Remove product key
 *
 * @return void
 */
function bf_delete_product_post_type_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'])) {
		try {
			delete_option('bf_product_post_type');

			$_SESSION['flashMessage'] = translate('Product post type is removed', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (\Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while removing product post type', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
