<?php

namespace BmbyForms\Pages\SettingsPage;

use function BmbyForms\bf_get_redirect_url;

/**
 * Remove all form connections and delete project key
 *
 * @return void
 */
function bf_disconnect_post_request_handler() {

	/**
	 * wpdb class
	 */
	global $wpdb;
	$redirectUrl = bf_get_redirect_url();

	if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'])) {
		try {
			delete_option('bf_lead_api_key');
			delete_option('bf_api_data');

			$wpdb->query("delete from wp_options where option_name like 'bf_match_%';");

			$_SESSION['flashMessage'] = translate('Api key and all connections are removed', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (\Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while bmby data removal', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
