<?php

namespace BmbyForms\Pages\SettingsPage;

use function BmbyForms\bf_get_redirect_url;

/**
 * Remove product key
 *
 * @return void
 */
function bf_disconnect_product_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'])) {
		global $wpdb;
		try {
			delete_option('bf_product_api_key');

			$productPostType = get_option('bf_product_post_type') ?: 'bmby_course';
			$meetingPostType = get_option('bf_meeting_post_type') ?: 'bmby_meeting';
			$sql = $wpdb->prepare( "DELETE {$wpdb->posts}, {$wpdb->postmeta} FROM {$wpdb->posts} LEFT JOIN {$wpdb->postmeta} ON {$wpdb->posts}.ID = {$wpdb->postmeta}.post_id 
													WHERE {$wpdb->posts}.post_type IN (%s, %s);", $productPostType, $meetingPostType);
			$wpdb->query($sql);

			$sql = $wpdb->prepare( "DELETE {$wpdb->terms},{$wpdb->termmeta}, {$wpdb->term_taxonomy}, {$wpdb->term_relationships} 
 											LEFT JOIN {$wpdb->terms} ON {$wpdb->terms}.term_id = {$wpdb->term_taxonomy}.term_id 
 											LEFT JOIN {$wpdb->term_relationships} ON {$wpdb->term_relationships}.term_taxonomy_id = {$wpdb->term_taxonomy}.term_taxonomy_id 
 											LEFT JOIN {$wpdb->termmeta} ON {$wpdb->termmeta}.term_id = {$wpdb->terms}.term_id 
											WHERE {$wpdb->term_taxonomy}.taxonomy IN (%s, %s, %s, %s);", 'sites', 'lecturers', 'specialities', 'time_slots');
			$wpdb->query($sql);

			$_SESSION['flashMessage'] = translate('Product api key is removed', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (\Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while product api removal', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
