<?php

namespace BmbyForms\Pages\SettingsPage;

use Exception;
use function BmbyForms\bf_get_redirect_url;

/**
 * Save custom column names for bmby products
 *
 * @return void
 */
function bf_save_meeting_meta_fields_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce'])
	    && wp_verify_nonce($_POST['_wpnonce'])
	    && !empty($_POST['meta_meeting_lecturer'])
	    && !empty($_POST['meta_meeting_date'])
	    && !empty($_POST['meta_meeting_start_time'])
	    && !empty($_POST['meta_meeting_end_time'])
	) {
		try{
			$metaMeetingLecturer = $_POST['meta_meeting_lecturer'];
			$metaMeetingDate = $_POST['meta_meeting_date'];
			$metaMeetingStartTime = $_POST['meta_meeting_start_time'];
			$metaMeetingEndTime = $_POST['meta_meeting_end_time'];

			delete_option('bf_meta_meeting_lecturer');
			delete_option('bf_meta_meeting_date');
			delete_option('bf_meta_meeting_start_time');
			delete_option('bf_meta_meeting_end_time');

			add_option('bf_meta_meeting_lecturer', $metaMeetingLecturer);
			add_option('bf_meta_meeting_date', $metaMeetingDate);
			add_option('bf_meta_meeting_start_time', $metaMeetingStartTime);
			add_option('bf_meta_meeting_end_time', $metaMeetingEndTime);

			$_SESSION['flashMessage'] = translate('Meta fields for meetings has been successfully saved', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while saving meetings meta fields', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
