<?php

namespace BmbyForms\Pages\SettingsPage;

use Exception;
use function BmbyForms\bf_get_redirect_url;

/**
 * @return void
 */
function bf_save_meeting_post_type_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce']) && !empty($_POST['meeting_post_type'])) {
		try{
			$meetingPostType = $_POST['meeting_post_type'];
			delete_option('bf_meeting_post_type');
			add_option('bf_meeting_post_type', $meetingPostType);

			$_SESSION['flashMessage'] = translate('Meeting post type has been successfully saved', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while saving meeting post type', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
