<?php

namespace BmbyForms\Pages\SettingsPage;

use Exception;
use function BmbyForms\bf_get_redirect_url;

/**
 * @return void
 */
function bf_save_payment_pages_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	try {
		require __DIR__ . '/../../../bmby-check-api-data.php';
		if (isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'])) {
			$successPageId = filter_var(trim($_POST['success_page']), FILTER_VALIDATE_INT, ["options" => ["min_range" => 1]]);
			$errorPageId = filter_var(trim($_POST['error_page']), FILTER_VALIDATE_INT, ["options" => ["min_range" => 1]]);

			if ($successPageId) {
				delete_option('bf_success_page');
				add_option('bf_success_page', $successPageId);
			}

			if ($errorPageId) {
				delete_option('bf_error_page');
				add_option('bf_error_page', $errorPageId);
			}

			$_SESSION['flashMessage'] = translate('Payment gateway pages are successfully saved', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} else {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
			exit();
		}
	} catch (Exception $e) {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('An error has occurred', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		exit();
	}
}
