<?php

namespace BmbyForms\Pages\SettingsPage;

use Exception;
use function BmbyForms\bf_get_redirect_url;

/**
 * Save custom column names for bmby products
 *
 * @return void
 */
function bf_save_product_column_names_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce'])
	    && wp_verify_nonce($_POST['_wpnonce'])
	    && !empty($_POST['column_id'])
	    && !empty($_POST['column_catalog'])
	    && !empty($_POST['column_title'])
	    && !empty($_POST['column_price'])
	    && !empty($_POST['column_start_date'])
	    && !empty($_POST['column_end_date'])
	) {
		try{
			$columnId = $_POST['column_id'];
			$columnCatalog = $_POST['column_catalog'];
			$columnTitle = $_POST['column_title'];
			$columnPrice = $_POST['column_price'];
			$columnStartDate = $_POST['column_start_date'];
			$columnEndDate = $_POST['column_end_date'];

			delete_option('bf_column_id');
			delete_option('bf_column_catalog');
			delete_option('bf_column_title');
			delete_option('bf_column_price');
			delete_option('bf_column_start_date');
			delete_option('bf_column_end_date');

			add_option('bf_column_id', $columnId);
			add_option('bf_column_catalog', $columnCatalog);
			add_option('bf_column_title', $columnTitle);
			add_option('bf_column_price', $columnPrice);
			add_option('bf_column_start_date', $columnStartDate);
			add_option('bf_column_end_date', $columnEndDate);

			$_SESSION['flashMessage'] = translate('Names for columns for bmby products has been successfully saved', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while saving column names', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
