<?php

namespace BmbyForms\Pages\SettingsPage;

use Exception;
use function BmbyForms\bf_get_redirect_url;

/**
 * Save custom column names for bmby products
 *
 * @return void
 */
function bf_save_product_meta_fields_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce'])
	    && wp_verify_nonce($_POST['_wpnonce'])
	    && !empty($_POST['meta_product_id'])
	    && !empty($_POST['meta_product_type'])
	    && !empty($_POST['meta_product_price'])
	    && !empty($_POST['meta_product_sku'])
	    && !empty($_POST['meta_product_start_date'])
	    && !empty($_POST['meta_product_end_date'])
	    && !empty($_POST['meta_product_site'])

	) {
		try{
			$metaProductID = $_POST['meta_product_id'];
			$metaProductType = $_POST['meta_product_type'];
			$metaProductPrice = $_POST['meta_product_price'];
			$metaProductSku = $_POST['meta_product_sku'];
			$metaProductStartDate = $_POST['meta_product_start_date'];
			$metaProductEndDate = $_POST['meta_product_end_date'];
			$metaProductSite = $_POST['meta_product_site'];

			delete_option('bf_meta_product_product_id');
			delete_option('bf_meta_product_product_type');
			delete_option('bf_meta_product_price');
			delete_option('bf_meta_product_sku');
			delete_option('bf_meta_product_start_date');
			delete_option('bf_meta_product_end_date');
			delete_option('bf_meta_product_site');

			add_option('bf_meta_product_product_id', $metaProductID);
			add_option('bf_meta_product_product_type', $metaProductType);
			add_option('bf_meta_product_price', $metaProductPrice);
			add_option('bf_meta_product_sku', $metaProductSku);
			add_option('bf_meta_product_start_date', $metaProductStartDate);
			add_option('bf_meta_product_end_date', $metaProductEndDate);
			add_option('bf_meta_product_site', $metaProductSite);

			$_SESSION['flashMessage'] = translate('Meta fields for bmby products has been successfully saved', 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
		} catch (Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while saving product meta fields', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
