<?php

namespace BmbyForms\Pages\SettingsPage;

/**
 * Inserts a Settings link when plugin is activated in plugins page
 *
 * @param $links
 * @param $file
 *
 * @return array
 */
function bf_add_settings_link_upon_activation($links, $file) {
	if ($file == 'bmby-forms/bmby-forms.php') {
		if (empty($links)) {
			$links = [];
		}

		/*
		 * Insert the link at the beginning
		 */
		$settingLink = '<a href="/wp-admin/admin.php?page=bmby-forms%2Fsettings.php">' . __("Settings", "bmby-forms") . '</a>';
		array_unshift($links, $settingLink);
	}

	return $links;
}

/**
 * @return void
 */
function bf_settings_page() {
	global $wpdb;

	$leadApiKey = get_option('bf_lead_api_key', null);
	$productApiKey = get_option('bf_product_api_key', null);
	$metaField = get_option('bf_meta_field', null);
	$productPostType = get_option('bf_product_post_type', null);
	$meetingPostType = get_option('bf_meeting_post_type', null);

	$metaProductID = get_option('bf_meta_product_product_id', null);
	$metaProductType = get_option('bf_meta_product_product_type', null);
	$metaProductPrice = get_option('bf_meta_product_price', null);
	$metaProductSku = get_option('bf_meta_product_sku', null);
	$metaProductStartDate = get_option('bf_meta_product_start_date', null);
	$metaProductEndDate = get_option('bf_meta_product_end_date', null);
	$metaProductSite = get_option('bf_meta_product_site', null);

	$metaMeetingLecturer = get_option('bf_meta_meeting_lecturer', null);
	$metaMeetingDate = get_option('bf_meta_meeting_date', null);
	$metaMeetingStartTime = get_option('bf_meta_meeting_start_time', null);
	$metaMeetingEndTime = get_option('bf_meta_meeting_end_time', null);

	$columnID = get_option('bf_column_id', null);
	$columnCatalog = get_option('bf_column_catalog', null);
	$columnTitle = get_option('bf_column_title', null);
	$columnPrice = get_option('bf_column_price', null);
	$columnStartDate = get_option('bf_column_start_date', null);
	$columnEndDate = get_option('bf_column_end_date', null);

	$sql = $wpdb->prepare( "SELECT ID, post_title FROM {$wpdb->posts} WHERE {$wpdb->posts}.post_type = %s AND {$wpdb->posts}.post_status = 'publish' ORDER BY ID DESC;", 'page');
	$pages = $wpdb->get_results($sql, ARRAY_A);

	$successPageId = get_option('bf_success_page');
	$errorPageId = get_option('bf_error_page');

	$userRoles = wp_roles()->role_names;
	$returningUserRole = get_option('bf_returning_user_role');

	require_once 'settings_page.view.html';
}
