<?php

namespace BmbyForms\Pages\SettingsPage;

use function BmbyForms\bf_get_redirect_url;
use function BmbyForms\Requests\bf_get_dyn_var_request;

/**
 * Validate api key and save bmby data
 *
 * @return void
 */
function bf_settings_post_request_handler() {
	$redirectUrl = bf_get_redirect_url();
	if (isset($_POST['_wpnonce']) && !empty($_POST['api_key']) && wp_verify_nonce($_POST['_wpnonce'])) {
		$leadApiKey = $_POST['api_key'];
		global $mbeatServer;

		//get api data
		try {
			$response = wp_remote_get( "{$mbeatServer}/api/clients/keys/{$leadApiKey}/is-valid", array('sslverify' => false));
			$zap = json_decode($response['body'], true);

			if (empty($zap) || !empty($zap['error'])) {
				$_SESSION['type'] = translate('error', 'bmby-forms');
				$_SESSION['flashMessage'] = translate('There is no bmby data associated with this api key', 'bmby-forms');
				header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
			}

			if (empty($zap['ProjectID']) || empty($zap['CompanyID'])) {
				$_SESSION['type'] = translate('error', 'bmby-forms');
				$_SESSION['flashMessage'] = translate('Project id or company id is absent', 'bmby-forms');
				header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
			}

			unset($zap['general1']);
			unset($zap['general2']);
			unset($zap['UserID']);
			unset($zap['MediaID']);

		} catch (\Exception $e) {
			$_SESSION['type'] = translate('error', 'bmby-forms');
			$_SESSION['flashMessage'] = translate(sprintf('%s: %s', 'Error while api data retrieval', $e->getMessage()), 'bmby-forms');
			header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
		}

		delete_option('bf_lead_api_key');
		delete_option('bf_api_data');
		//if db collate in wp config is utf8 and is not encoded then option cannot be retrieved via get_option() function
		//on client's wordpress test5.brandale.co.il works fine without iconv here
		//iconv here does not allow to save bf_api_data in db which causes errors
//		$zap['Title'] = iconv('UTF-8', 'windows-1255', $zap['Title']);

		add_option('bf_lead_api_key', $leadApiKey);
		add_option('bf_api_data', $zap);

		$dynVars = bf_get_dyn_var_request();

		delete_option('bf_dyn_vars');
		add_option('bf_dyn_vars', $dynVars);

		$_SESSION['flashMessage'] = translate('Api key successfully saved', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php"));
	} else {
		$_SESSION['type'] = translate('error', 'bmby-forms');
		$_SESSION['flashMessage'] = translate('Invalid input data specified', 'bmby-forms');
		header('Location: ' . esc_url("{$redirectUrl}?page=bmby-forms%2Fsettings.php")); exit();
	}
}
