<?php

namespace BmbyForms\Taxonomies;

/**
 * @param $productPostType
 */
function register_custom_taxonomy($productPostType) {
	if (!taxonomy_exists('sites')) {
		register_taxonomy('sites', array($productPostType), array(
			'hierarchical'      => false,
			'labels'            => array(
				'name'              => __('Sites', 'bmby-forms'),
				'singular_name'     => __('Site', 'bmby-forms'),
				'search_items'      => __('Search Sites', 'bmby-forms'),
				'all_items'         => __('All Sites', 'bmby-forms'),
				'edit_item'         => __('Edit Site', 'bmby-forms'),
				'update_item'       => __('Update Site', 'bmby-forms'),
				'add_new_item'      => __('Add Site', 'bmby-forms'),
				'new_item_name'     => __('New Site Name', 'bmby-forms'),
				'menu_name'         => __('Sites', 'bmby-forms'),
			),
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => array('slug' => 'sites'),
		));
	}

	if (!taxonomy_exists('lecturers')) {
		register_taxonomy('lecturers', array($productPostType), array(
			'hierarchical'      => false,
			'labels'            => array(
				'name'              => __('Lecturers', 'bmby-forms'),
				'singular_name'     => __('Lecturer', 'bmby-forms'),
				'search_items'      => __('Search Lecturers', 'bmby-forms'),
				'all_items'         => __('All Lecturers', 'bmby-forms'),
				'edit_item'         => __('Edit Lecturer', 'bmby-forms'),
				'update_item'       => __('Update Lecturer', 'bmby-forms'),
				'add_new_item'      => __('Add Lecturer', 'bmby-forms'),
				'new_item_name'     => __('New Lecturer Name', 'bmby-forms'),
				'menu_name'         => __('Lecturers', 'bmby-forms'),
			),
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => array('slug' => 'lecturers'),
		));
	}

	if (!taxonomy_exists('specialities')) {
		register_taxonomy('specialities', array($productPostType), array(
			'hierarchical'      => false,
			'labels'            => array(
				'name'              => __('Specialities', 'bmby-forms'),
				'singular_name'     => __('Specialities', 'bmby-forms'),
				'search_items'      => __('Search Specialities', 'bmby-forms'),
				'all_items'         => __('All Specialities', 'bmby-forms'),
				'edit_item'         => __('Edit Speciality', 'bmby-forms'),
				'update_item'       => __('Update Speciality', 'bmby-forms'),
				'add_new_item'      => __('Add Speciality', 'bmby-forms'),
				'new_item_name'     => __('New Speciality Name', 'bmby-forms'),
				'menu_name'         => __('Specialities', 'bmby-forms'),
			),
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => array('slug' => 'specialities'),
		));
	}

	if (!taxonomy_exists('time_slots')) {
		register_taxonomy('time_slots', array($productPostType), array(
			'hierarchical'      => false,
			'labels'            => array(
				'name'              => __('TimeSlots', 'bmby-forms'),
				'singular_name'     => __('TimeSlots', 'bmby-forms'),
				'search_items'      => __('Search TimeSlots', 'bmby-forms'),
				'all_items'         => __('All TimeSlots', 'bmby-forms'),
				'edit_item'         => __('Edit TimeSlot', 'bmby-forms'),
				'update_item'       => __('Update TimeSlot', 'bmby-forms'),
				'add_new_item'      => __('Add TimeSlot', 'bmby-forms'),
				'new_item_name'     => __('New TimeSlot Name', 'bmby-forms'),
				'menu_name'         => __('TimeSlots', 'bmby-forms'),
			),
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => array('slug' => 'time_slots'),
		));
	}

	if (!taxonomy_exists('semesters')) {
		register_taxonomy('semesters', array($productPostType), array(
			'hierarchical'      => false,
			'labels'            => array(
				'name'              => __('Semesters', 'bmby-forms'),
				'singular_name'     => __('Semesters', 'bmby-forms'),
				'search_items'      => __('Search Semesters', 'bmby-forms'),
				'all_items'         => __('All Semesters', 'bmby-forms'),
				'edit_item'         => __('Edit Semester', 'bmby-forms'),
				'update_item'       => __('Update Semester', 'bmby-forms'),
				'add_new_item'      => __('Add Semester', 'bmby-forms'),
				'new_item_name'     => __('New Semester Name', 'bmby-forms'),
				'menu_name'         => __('Semesters', 'bmby-forms'),
			),
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => array('slug' => 'semesters'),
		));
	}
}
