<?php

namespace BmbyForms;

/**
 * @return bool
 */
function bf_is_multisite() {
	if (defined('MULTISITE')) {
		return MULTISITE;
	}

	if (defined('SUBDOMAIN_INSTALL') || defined('VHOST') || defined('SUNRISE')) {
		return true;
	}

	return false;
}

/**
 * @param $plugin
 *
 * @return bool
 */
function bf_is_plugin_active_for_network($plugin) {
	if (!bf_is_multisite()) {
		return false;
	}

	$plugins = get_site_option('active_sitewide_plugins');
	if (isset($plugins[$plugin])) {
		return true;
	}

	return false;
}

/**
 * @param $plugin
 *
 * @return bool
 */
function bf_is_plugin_active($plugin) {
	return in_array($plugin, (array) get_option('active_plugins', array()), true) || bf_is_plugin_active_for_network($plugin);
}

/**
 * @return void
 */
function bf_is_other_form_plugins_are_active() {
	if (
		!bf_is_plugin_active('contact-form-7/wp-contact-form-7.php') ||
		!bf_is_plugin_active('elementor/elementor.php') ||
		!bf_is_plugin_active('elementor-pro/elementor-pro.php')
	) {
		wp_die(__('Contact Form 7, Elementor and ElementorPro plugins must be installed and activated in order for Bmby Forms plugin to work', 'bmby-forms'),
			__('Error', 'bmby-forms'), array(
				'response' => 400,
				'back_link' => esc_url('/wp-admin/plugins.php?plugin_status=all&paged=1&s')
			)
		);
	}
}
