<?php

namespace BmbyForms;

error_reporting(E_ALL);
ini_set('display_errors', 0);

/**
 * Plugin Name: bmby-forms
 * Plugin URI: http://wordpress.bmby.com/wp-admin/admin.php?page=bmby-forms%2Fwordpress-forms.php
 * Description: Bmby Forms plugin.
 * Version: 1.0.1
 * Author: alex.i
 * Text Domain: bmby-forms
 * Domain Path: /languages
 **/

define('BMBY_FORMS_PLUGIN_VERSION', '1.0.1');

session_start();

require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'wordpress_forms_page', 'wordpress_forms_page');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'wordpress_forms_page', 'wordpress_forms_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'wordpress_forms_page', 'disconnect_form_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'form_fields_page', 'form_fields_page');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'form_fields_page', 'form_fields_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'settings_page');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'settings_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'disconnect_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'product_settings_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'disconnect_product_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_meta_field_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_meta_field_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_product_post_type_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_product_post_type_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_meeting_post_type_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_meeting_post_type_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_product_column_names_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_product_column_names_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_product_meta_fields_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_product_meta_fields_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_meeting_meta_fields_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_meeting_meta_fields_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_payment_pages_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_payment_pages_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'save_returning_user_roles_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'settings_page', 'delete_returning_user_role_post_request');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'products_page', 'products_page');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'products_page', 'import_products');
require_once sprintf('%s/admin/pages/%s/%s.php', __DIR__, 'payment_form_page', 'payment_form_page');
//functions which intercepts submit data from forms
require sprintf('/%s/admin/requests/%s.php', plugin_dir_path(__FILE__), 'create_lead_request');
require_once sprintf('%s/admin/interceptors/%s.php', __DIR__, 'cf7_form_submit_interceptor');
require_once sprintf('%s/admin/interceptors/%s.php', __DIR__, 'elementor_form_submit_interceptor');
require sprintf('/%s/admin/interceptors/%s.php', plugin_dir_path(__FILE__), 'cf7_form_structure_updated');
require sprintf('/%s/admin/interceptors/%s.php', plugin_dir_path(__FILE__), 'elementor_form_structure_updated');
require sprintf('/%s/admin/requests/%s.php', plugin_dir_path(__FILE__), 'get_dyn_vars_request');
require sprintf('/%s/admin/callbacks/%s.php', plugin_dir_path(__FILE__), 'update_dyn_vars_callback');
require sprintf('/%s/admin/interceptors/%s.php', plugin_dir_path(__FILE__), 'create_lead_after_new_user_registered');
require sprintf('/%s/admin/taxonomies/%s.php', plugin_dir_path(__FILE__), 'create_custom_taxonomies');
require sprintf('/%s/admin/taxonomies/%s.php', plugin_dir_path(__FILE__), 'create_custom_terms');
require 'settings.php';
require 'global-functions.php';

/**
 * Add Bmby Forms in admin menu
 */
function add_pages() {
	add_menu_page(
		__('Bmby', 'bmby-forms'),
		__('Bmby', 'bmby-forms'),
		'manage_options',
		'bmby-forms/wordpress-forms.php',
		'BmbyForms\Pages\WordpressFormsPage\bf_wordpress_forms_page',
		plugins_url('bmby-forms/admin/images/menu_icon.ico'),
		99
	);

	add_submenu_page(
		null,    // set to null to remove menu slug
//		'bmby-forms/wordpress-forms.php',    // set to null to remove menu slug
		__('Form Fields', 'bmby-forms'),
		__('Form Fields', 'bmby-forms'),
		'manage_options',
		'bmby-forms/form-fields.php',
		'BmbyForms\Pages\FormFieldsPage\bf_form_fields_page'
	);

	add_submenu_page(
		'bmby-forms/wordpress-forms.php',
		__('Settings', 'bmby-forms'),
		__('Settings', 'bmby-forms'),
		'manage_options',
		'bmby-forms/settings.php',
		'BmbyForms\Pages\SettingsPage\bf_settings_page'
	);

	add_submenu_page(
		'bmby-forms/wordpress-forms.php',
		__('Bmby Products', 'bmby-forms'),
		__('Bmby Products', 'bmby-forms'),
		'manage_options',
		'bmby-products/products.php',
		'BmbyForms\Pages\ProductsPage\bf_bmby_products_page'
	);
}

add_action('admin_menu', 'BmbyForms\add_pages');

//add handler for post request for form of the settings form
add_action('admin_post_bf_settings_post_request', 'BmbyForms\Pages\SettingsPage\bf_settings_post_request_handler');

//add handler for post request for disconnect button on the settings form
add_action('admin_post_bf_disconnect_post_request', 'BmbyForms\Pages\SettingsPage\bf_disconnect_post_request_handler');

//add handler for post request for form of the product settings form
add_action('admin_post_bf_product_settings_post_request', 'BmbyForms\Pages\SettingsPage\bf_product_settings_post_request_handler');

//add handler for post request for disconnect from products api button on the settings form
add_action('admin_post_bf_disconnect_product_post_request', 'BmbyForms\Pages\SettingsPage\bf_disconnect_product_post_request_handler');

//add handler for post request for saving meta field for post request on the settings form
add_action('admin_post_bf_save_meta_field_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_meta_field_post_request_handler');

//add handler for delete meta field for post request on the settings form
add_action('admin_post_bf_delete_meta_field_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_meta_field_post_request_handler');

//add handler for post request from settings form that saves type of post that holds courses in posts db table
add_action('admin_post_bf_save_product_post_type_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_product_post_type_post_request_handler');

//add handler for post request from settings form that deletes type of post that holds courses in posts db table
add_action('admin_post_bf_delete_product_post_type_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_product_post_type_post_request_handler');

//add handler for post request from settings form that saves type of post that holds meetings in posts db table
add_action('admin_post_bf_save_meeting_post_type_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_meeting_post_type_post_request_handler');

//add handler for post request from settings form that deletes type of post that holds meetings in posts db table
add_action('admin_post_bf_delete_meeting_post_type_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_meeting_post_type_post_request_handler');

//add handler for post request that saves names of the columns for courses
add_action('admin_post_bf_save_product_column_names_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_product_column_names_post_request_handler');

//add handler for post request that removes names of the columns for courses
add_action('admin_post_bf_delete_product_column_names_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_product_column_names_post_request_handler');

//add handler for courses meta fields
add_action('admin_post_bf_save_product_meta_fields_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_product_meta_fields_post_request_handler');

//add handler for courses meta fields
add_action('admin_post_bf_delete_product_meta_fields_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_product_meta_fields_post_request_handler');

//add handler for meeting meta fields
add_action('admin_post_bf_save_meeting_meta_fields_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_meeting_meta_fields_post_request_handler');

//add handler for meeting meta fields
add_action('admin_post_bf_delete_meeting_meta_fields_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_meeting_meta_fields_post_request_handler');

//add handler for payment pages saving
add_action('admin_post_bf_save_payment_pages_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_payment_pages_post_request_handler');

//add handler for payment pages deleting
add_action('admin_post_bf_delete_payment_pages_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_payment_pages_post_request_handler');

//add role for returning user
add_action('admin_post_bf_save_returning_user_roles_post_request', 'BmbyForms\Pages\SettingsPage\bf_save_returning_user_roles_post_request_handler');

//remove role for returning user
add_action('admin_post_bf_delete_returning_user_role_post_request', 'BmbyForms\Pages\SettingsPage\bf_delete_returning_user_role_post_request_handler');

add_action('admin_post_bf_import_products_post_request', 'BmbyForms\Pages\ProductsPage\bf_import_products_post_request_handler');

//add handler for post request for form on the wordpress forms page
add_action('admin_post_bf_wordpress_forms_post_request', 'BmbyForms\Pages\WordpressFormsPage\bf_wordpress_forms_post_request_handler');

//add handler for WordPress form disconnect
add_action('admin_post_bf_disconnect_form_post_request', 'BmbyForms\Pages\WordpressFormsPage\bf_disconnect_form_post_request_handler');

//add handler for post request for form of the form_fields page
add_action('admin_post_bf_form_fields_post_request', 'BmbyForms\Pages\FormFieldsPage\bf_form_fields_post_request_handler');

add_action('wpcf7_before_send_mail', 'BmbyForms\Interceptors\bf_cf7_form_submit_interceptor', 10, 3);

add_action('elementor_pro/forms/new_record', 'BmbyForms\Interceptors\bf_elementor_form_submit_interceptor', 10, 2);

//Inserts a Settings link when plugin is activated in plugins page
add_filter('plugin_action_links', 'BmbyForms\Pages\SettingsPage\bf_add_settings_link_upon_activation', 10, 2);

/**
 * Add custom css
 */
function bf_plugin_css_js_setup() {
	wp_enqueue_style('bmby_forms_settings', plugins_url('/admin/css/settings.css', __FILE__));
	wp_enqueue_style('bmby_forms_form_fields', plugins_url('/admin/css/form_fields.css', __FILE__), array(), '3');
	wp_enqueue_style('bmby_forms_loader', plugins_url('/admin/css/preloader.css', __FILE__), array(), '1');
//	wp_enqueue_script( 'namespaceformyscript', 'http://locationofscript.com/myscript.js', array( 'jquery' ) );
}

add_action('admin_enqueue_scripts', 'BmbyForms\bf_plugin_css_js_setup');

add_action('wpcf7_after_update', 'BmbyForms\Interceptors\bf_cf7_form_structure_updated');
add_action('elementor/editor/after_save', 'BmbyForms\Interceptors\bf_elementor_form_structure_updated');

add_action('jet-engine-booking/user_register', 'BmbyForms\Interceptors\bf_create_lead_after_new_user_registered');

add_action('init', function () {
	global $wp_rewrite;
	add_feed('bmby-forms/callbacks/update-dyn-vars', 'BmbyForms\Callbacks\bf_update_dyn_vars_callback');
	$wp_rewrite->flush_rules();

	if (get_option('bf_product_api_key')) {
		$productPostType = get_option('bf_product_post_type') ?: 'bmby_course';

		Taxonomies\register_custom_taxonomy($productPostType);
		//this code must be uncommented only for dev_wordpress.bmby.com
//		if (!post_type_exists($meetingPostType)){
//			register_post_type($meetingPostType,
//				array(
//					'labels'      => array(
//						'name'          => 'שיעורים',
//					),
//					'public'      => true,
//					'has_archive' => true,
//					'rewrite'     => array('slug' => $meetingPostType),
//					'supports'    => array('title', 'editor', 'thumbnail', 'custom-fields', 'excerpt'),
//					'taxonomies'  => array('lecturers'),
//				)
//			);
//		}
//
//		if (!post_type_exists($productPostType)){
//			register_post_type($productPostType,
//				array(
//					'labels'      => array(
//						'name'          => 'קורסים',
//					),
//					'public'      => true,
//					'has_archive' => true,
//					'rewrite'     => array('slug' => $productPostType),
//					'supports'    => array('title', 'editor', 'thumbnail', 'custom-fields', 'excerpt'),
//					'taxonomies'  => array('sites'),
//				)
//			);
//		}
	}
});

add_action('wp_loaded', function() {
	$url = isset($_SERVER['REDIRECT_URL']) ? $_SERVER['REDIRECT_URL'] : (parse_url($_SERVER['REQUEST_URI'])['path'] != null ? parse_url($_SERVER['REQUEST_URI'])['path'] : '');
	if ($url === '/payment-form' ) {
		Pages\PaymentFormPage\bf_payment_form_page();
	}

	if ($url === '/bmby-forms/payment-form/create') {
		require_once sprintf('%s/%s.php', __DIR__, 'checkout');
		exit();
	}
});

add_action('template_redirect', function() {
	$url = isset($_SERVER['REDIRECT_URL']) ? $_SERVER['REDIRECT_URL'] : (parse_url($_SERVER['REQUEST_URI'])['path'] != null ? parse_url($_SERVER['REQUEST_URI'])['path'] : '');
	$successPageID = get_option('bf_success_page', null);
	if ($successPageID) {
		$successUrl = get_permalink($successPageID);
		$orderId = filter_var(trim($_GET['order_id']), FILTER_VALIDATE_INT, ["options" => ["min_range" => 1]]);
		$userId = get_current_user_id();
		if (strpos($successUrl, $url) !== false && isset($_GET['purchase_course_id']) &&  $userId > 0 && $orderId) {
			$meta = get_user_meta($userId, 'active_c', true);
			if ($meta === '' || $meta === false)
				$meta = [];

			$meta = array_merge($meta, explode(',', $_GET['purchase_course_id']));
			$meta = array_flip(array_flip($meta)); //remove duplicates, very handy
			update_user_meta($userId, 'active_c', $meta);

			//change user role
			if ($returningUserRole = get_option('bf_returning_user_role')) {
				$u = new \WP_User($userId);
				$u->add_role($returningUserRole);
			}

			//set order completed
			$order = wc_get_order($orderId);
			$order->update_status("wc-completed", 'Order', true);

			WC()->cart->empty_cart();
		}
	}
});
