<?php

namespace BmbyForms;

global $wpdb;
$products = [];

$metaProductId = get_option('bf_meta_product_product_id', null);
if (!$metaProductId) {
	exit();
}

foreach (WC()->cart->get_cart() as $cart_item) {
	$sql ="SELECT meta_value FROM {$wpdb->postmeta} pm WHERE pm.post_id = %d AND pm.meta_key = %s ORDER BY pm.meta_id DESC LIMIT 1;";
	$data = $wpdb->get_results($wpdb->prepare($sql, $cart_item['data']->get_id(), $metaProductId));
	$products[] = [
		'id' => $data[0]->meta_value,
		'post_id' => $cart_item['product_id'],
		'quantity' => $cart_item['quantity'],
		'price' => $cart_item['data']->get_price()
	];
}

header(sprintf('Location: /payment-form?products=%s', base64_encode(gzcompress(json_encode($products), 9))));
